typedef struct WEATHER_STATION weather_station;
struct WEATHER_STATION {
    string name;
    f64 temperature;
};

static const weather_station g_weather_station_data[] = {
    { StringLiteralConst("Abha"), 18.0 },
    { StringLiteralConst("Abidjan"), 26.0 },
    { StringLiteralConst("Abéché"), 29.4 },
    { StringLiteralConst("Accra"), 26.4 },
    { StringLiteralConst("Addis Ababa"), 16.0 },
    { StringLiteralConst("Adelaide"), 17.3 },
    { StringLiteralConst("Aden"), 29.1 },
    { StringLiteralConst("Ahvaz"), 25.4 },
    { StringLiteralConst("Albuquerque"), 14.0 },
    { StringLiteralConst("Alexandra"), 11.0 },
    { StringLiteralConst("Alexandria"), 20.0 },
    { StringLiteralConst("Algiers"), 18.2 },
    { StringLiteralConst("Alice Springs"), 21.0 },
    { StringLiteralConst("Almaty"), 10.0 },
    { StringLiteralConst("Amsterdam"), 10.2 },
    { StringLiteralConst("Anadyr"), -6.9 },
    { StringLiteralConst("Anchorage"), 2.8 },
    { StringLiteralConst("Andorra la Vella"), 9.8 },
    { StringLiteralConst("Ankara"), 12.0 },
    { StringLiteralConst("Antananarivo"), 17.9 },
    { StringLiteralConst("Antsiranana"), 25.2 },
    { StringLiteralConst("Arkhangelsk"), 1.3 },
    { StringLiteralConst("Ashgabat"), 17.1 },
    { StringLiteralConst("Asmara"), 15.6 },
    { StringLiteralConst("Assab"), 30.5 },
    { StringLiteralConst("Astana"), 3.5 },
    { StringLiteralConst("Athens"), 19.2 },
    { StringLiteralConst("Atlanta"), 17.0 },
    { StringLiteralConst("Auckland"), 15.2 },
    { StringLiteralConst("Austin"), 20.7 },
    { StringLiteralConst("Baghdad"), 22.77 },
    { StringLiteralConst("Baguio"), 19.5 },
    { StringLiteralConst("Baku"), 15.1 },
    { StringLiteralConst("Baltimore"), 13.1 },
    { StringLiteralConst("Bamako"), 27.8 },
    { StringLiteralConst("Bangkok"), 28.6 },
    { StringLiteralConst("Bangui"), 26.0 },
    { StringLiteralConst("Banjul"), 26.0 },
    { StringLiteralConst("Barcelona"), 18.2 },
    { StringLiteralConst("Bata"), 25.1 },
    { StringLiteralConst("Batumi"), 14.0 },
    { StringLiteralConst("Beijing"), 12.9 },
    { StringLiteralConst("Beirut"), 20.9 },
    { StringLiteralConst("Belgrade"), 12.5 },
    { StringLiteralConst("Belize City"), 26.7 },
    { StringLiteralConst("Benghazi"), 19.9 },
    { StringLiteralConst("Bergen"), 7.7 },
    { StringLiteralConst("Berlin"), 10.3 },
    { StringLiteralConst("Bilbao"), 14.7 },
    { StringLiteralConst("Birao"), 26.5 },
    { StringLiteralConst("Bishkek"), 11.3 },
    { StringLiteralConst("Bissau"), 27.0 },
    { StringLiteralConst("Blantyre"), 22.2 },
    { StringLiteralConst("Bloemfontein"), 15.6 },
    { StringLiteralConst("Boise"), 11.4 },
    { StringLiteralConst("Bordeaux"), 14.2 },
    { StringLiteralConst("Bosaso"), 30.0 },
    { StringLiteralConst("Boston"), 10.9 },
    { StringLiteralConst("Bouaké"), 26.0 },
    { StringLiteralConst("Bratislava"), 10.5 },
    { StringLiteralConst("Brazzaville"), 25.0 },
    { StringLiteralConst("Bridgetown"), 27.0 },
    { StringLiteralConst("Brisbane"), 21.4 },
    { StringLiteralConst("Brussels"), 10.5 },
    { StringLiteralConst("Bucharest"), 10.8 },
    { StringLiteralConst("Budapest"), 11.3 },
    { StringLiteralConst("Bujumbura"), 23.8 },
    { StringLiteralConst("Bulawayo"), 18.9 },
    { StringLiteralConst("Burnie"), 13.1 },
    { StringLiteralConst("Busan"), 15.0 },
    { StringLiteralConst("Cabo San Lucas"), 23.9 },
    { StringLiteralConst("Cairns"), 25.0 },
    { StringLiteralConst("Cairo"), 21.4 },
    { StringLiteralConst("Calgary"), 4.4 },
    { StringLiteralConst("Canberra"), 13.1 },
    { StringLiteralConst("Cape Town"), 16.2 },
    { StringLiteralConst("Changsha"), 17.4 },
    { StringLiteralConst("Charlotte"), 16.1 },
    { StringLiteralConst("Chiang Mai"), 25.8 },
    { StringLiteralConst("Chicago"), 9.8 },
    { StringLiteralConst("Chihuahua"), 18.6 },
    { StringLiteralConst("Chișinău"), 10.2 },
    { StringLiteralConst("Chittagong"), 25.9 },
    { StringLiteralConst("Chongqing"), 18.6 },
    { StringLiteralConst("Christchurch"), 12.2 },
    { StringLiteralConst("City of San Marino"), 11.8 },
    { StringLiteralConst("Colombo"), 27.4 },
    { StringLiteralConst("Columbus"), 11.7 },
    { StringLiteralConst("Conakry"), 26.4 },
    { StringLiteralConst("Copenhagen"), 9.1 },
    { StringLiteralConst("Cotonou"), 27.2 },
    { StringLiteralConst("Cracow"), 9.3 },
    { StringLiteralConst("Da Lat"), 17.9 },
    { StringLiteralConst("Da Nang"), 25.8 },
    { StringLiteralConst("Dakar"), 24.0 },
    { StringLiteralConst("Dallas"), 19.0 },
    { StringLiteralConst("Damascus"), 17.0 },
    { StringLiteralConst("Dampier"), 26.4 },
    { StringLiteralConst("Dar es Salaam"), 25.8 },
    { StringLiteralConst("Darwin"), 27.6 },
    { StringLiteralConst("Denpasar"), 23.7 },
    { StringLiteralConst("Denver"), 10.4 },
    { StringLiteralConst("Detroit"), 10.0 },
    { StringLiteralConst("Dhaka"), 25.9 },
    { StringLiteralConst("Dikson"), -11.1 },
    { StringLiteralConst("Dili"), 26.6 },
    { StringLiteralConst("Djibouti"), 29.9 },
    { StringLiteralConst("Dodoma"), 22.7 },
    { StringLiteralConst("Dolisie"), 24.0 },
    { StringLiteralConst("Douala"), 26.7 },
    { StringLiteralConst("Dubai"), 26.9 },
    { StringLiteralConst("Dublin"), 9.8 },
    { StringLiteralConst("Dunedin"), 11.1 },
    { StringLiteralConst("Durban"), 20.6 },
    { StringLiteralConst("Dushanbe"), 14.7 },
    { StringLiteralConst("Edinburgh"), 9.3 },
    { StringLiteralConst("Edmonton"), 4.2 },
    { StringLiteralConst("El Paso"), 18.1 },
    { StringLiteralConst("Entebbe"), 21.0 },
    { StringLiteralConst("Erbil"), 19.5 },
    { StringLiteralConst("Erzurum"), 5.1 },
    { StringLiteralConst("Fairbanks"), -2.3 },
    { StringLiteralConst("Fianarantsoa"), 17.9 },
    { StringLiteralConst("Flores,  Petén"), 26.4 },
    { StringLiteralConst("Frankfurt"), 10.6 },
    { StringLiteralConst("Fresno"), 17.9 },
    { StringLiteralConst("Fukuoka"), 17.0 },
    { StringLiteralConst("Gabès"), 19.5 },
    { StringLiteralConst("Gaborone"), 21.0 },
    { StringLiteralConst("Gagnoa"), 26.0 },
    { StringLiteralConst("Gangtok"), 15.2 },
    { StringLiteralConst("Garissa"), 29.3 },
    { StringLiteralConst("Garoua"), 28.3 },
    { StringLiteralConst("George Town"), 27.9 },
    { StringLiteralConst("Ghanzi"), 21.4 },
    { StringLiteralConst("Gjoa Haven"), -14.4 },
    { StringLiteralConst("Guadalajara"), 20.9 },
    { StringLiteralConst("Guangzhou"), 22.4 },
    { StringLiteralConst("Guatemala City"), 20.4 },
    { StringLiteralConst("Halifax"), 7.5 },
    { StringLiteralConst("Hamburg"), 9.7 },
    { StringLiteralConst("Hamilton"), 13.8 },
    { StringLiteralConst("Hanga Roa"), 20.5 },
    { StringLiteralConst("Hanoi"), 23.6 },
    { StringLiteralConst("Harare"), 18.4 },
    { StringLiteralConst("Harbin"), 5.0 },
    { StringLiteralConst("Hargeisa"), 21.7 },
    { StringLiteralConst("Hat Yai"), 27.0 },
    { StringLiteralConst("Havana"), 25.2 },
    { StringLiteralConst("Helsinki"), 5.9 },
    { StringLiteralConst("Heraklion"), 18.9 },
    { StringLiteralConst("Hiroshima"), 16.3 },
    { StringLiteralConst("Ho Chi Minh City"), 27.4 },
    { StringLiteralConst("Hobart"), 12.7 },
    { StringLiteralConst("Hong Kong"), 23.3 },
    { StringLiteralConst("Honiara"), 26.5 },
    { StringLiteralConst("Honolulu"), 25.4 },
    { StringLiteralConst("Houston"), 20.8 },
    { StringLiteralConst("Ifrane"), 11.4 },
    { StringLiteralConst("Indianapolis"), 11.8 },
    { StringLiteralConst("Iqaluit"), -9.3 },
    { StringLiteralConst("Irkutsk"), 1.0 },
    { StringLiteralConst("Istanbul"), 13.9 },
    { StringLiteralConst("İzmir"), 17.9 },
    { StringLiteralConst("Jacksonville"), 20.3 },
    { StringLiteralConst("Jakarta"), 26.7 },
    { StringLiteralConst("Jayapura"), 27.0 },
    { StringLiteralConst("Jerusalem"), 18.3 },
    { StringLiteralConst("Johannesburg"), 15.5 },
    { StringLiteralConst("Jos"), 22.8 },
    { StringLiteralConst("Juba"), 27.8 },
    { StringLiteralConst("Kabul"), 12.1 },
    { StringLiteralConst("Kampala"), 20.0 },
    { StringLiteralConst("Kandi"), 27.7 },
    { StringLiteralConst("Kankan"), 26.5 },
    { StringLiteralConst("Kano"), 26.4 },
    { StringLiteralConst("Kansas City"), 12.5 },
    { StringLiteralConst("Karachi"), 26.0 },
    { StringLiteralConst("Karonga"), 24.4 },
    { StringLiteralConst("Kathmandu"), 18.3 },
    { StringLiteralConst("Khartoum"), 29.9 },
    { StringLiteralConst("Kingston"), 27.4 },
    { StringLiteralConst("Kinshasa"), 25.3 },
    { StringLiteralConst("Kolkata"), 26.7 },
    { StringLiteralConst("Kuala Lumpur"), 27.3 },
    { StringLiteralConst("Kumasi"), 26.0 },
    { StringLiteralConst("Kunming"), 15.7 },
    { StringLiteralConst("Kuopio"), 3.4 },
    { StringLiteralConst("Kuwait City"), 25.7 },
    { StringLiteralConst("Kyiv"), 8.4 },
    { StringLiteralConst("Kyoto"), 15.8 },
    { StringLiteralConst("La Ceiba"), 26.2 },
    { StringLiteralConst("La Paz"), 23.7 },
    { StringLiteralConst("Lagos"), 26.8 },
    { StringLiteralConst("Lahore"), 24.3 },
    { StringLiteralConst("Lake Havasu City"), 23.7 },
    { StringLiteralConst("Lake Tekapo"), 8.7 },
    { StringLiteralConst("Las Palmas de Gran Canaria"), 21.2 },
    { StringLiteralConst("Las Vegas"), 20.3 },
    { StringLiteralConst("Launceston"), 13.1 },
    { StringLiteralConst("Lhasa"), 7.6 },
    { StringLiteralConst("Libreville"), 25.9 },
    { StringLiteralConst("Lisbon"), 17.5 },
    { StringLiteralConst("Livingstone"), 21.8 },
    { StringLiteralConst("Ljubljana"), 10.9 },
    { StringLiteralConst("Lodwar"), 29.3 },
    { StringLiteralConst("Lomé"), 26.9 },
    { StringLiteralConst("London"), 11.3 },
    { StringLiteralConst("Los Angeles"), 18.6 },
    { StringLiteralConst("Louisville"), 13.9 },
    { StringLiteralConst("Luanda"), 25.8 },
    { StringLiteralConst("Lubumbashi"), 20.8 },
    { StringLiteralConst("Lusaka"), 19.9 },
    { StringLiteralConst("Luxembourg City"), 9.3 },
    { StringLiteralConst("Lviv"), 7.8 },
    { StringLiteralConst("Lyon"), 12.5 },
    { StringLiteralConst("Madrid"), 15.0 },
    { StringLiteralConst("Mahajanga"), 26.3 },
    { StringLiteralConst("Makassar"), 26.7 },
    { StringLiteralConst("Makurdi"), 26.0 },
    { StringLiteralConst("Malabo"), 26.3 },
    { StringLiteralConst("Malé"), 28.0 },
    { StringLiteralConst("Managua"), 27.3 },
    { StringLiteralConst("Manama"), 26.5 },
    { StringLiteralConst("Mandalay"), 28.0 },
    { StringLiteralConst("Mango"), 28.1 },
    { StringLiteralConst("Manila"), 28.4 },
    { StringLiteralConst("Maputo"), 22.8 },
    { StringLiteralConst("Marrakesh"), 19.6 },
    { StringLiteralConst("Marseille"), 15.8 },
    { StringLiteralConst("Maun"), 22.4 },
    { StringLiteralConst("Medan"), 26.5 },
    { StringLiteralConst("Mek'ele"), 22.7 },
    { StringLiteralConst("Melbourne"), 15.1 },
    { StringLiteralConst("Memphis"), 17.2 },
    { StringLiteralConst("Mexicali"), 23.1 },
    { StringLiteralConst("Mexico City"), 17.5 },
    { StringLiteralConst("Miami"), 24.9 },
    { StringLiteralConst("Milan"), 13.0 },
    { StringLiteralConst("Milwaukee"), 8.9 },
    { StringLiteralConst("Minneapolis"), 7.8 },
    { StringLiteralConst("Minsk"), 6.7 },
    { StringLiteralConst("Mogadishu"), 27.1 },
    { StringLiteralConst("Mombasa"), 26.3 },
    { StringLiteralConst("Monaco"), 16.4 },
    { StringLiteralConst("Moncton"), 6.1 },
    { StringLiteralConst("Monterrey"), 22.3 },
    { StringLiteralConst("Montreal"), 6.8 },
    { StringLiteralConst("Moscow"), 5.8 },
    { StringLiteralConst("Mumbai"), 27.1 },
    { StringLiteralConst("Murmansk"), 0.6 },
    { StringLiteralConst("Muscat"), 28.0 },
    { StringLiteralConst("Mzuzu"), 17.7 },
    { StringLiteralConst("N'Djamena"), 28.3 },
    { StringLiteralConst("Naha"), 23.1 },
    { StringLiteralConst("Nairobi"), 17.8 },
    { StringLiteralConst("Nakhon Ratchasima"), 27.3 },
    { StringLiteralConst("Napier"), 14.6 },
    { StringLiteralConst("Napoli"), 15.9 },
    { StringLiteralConst("Nashville"), 15.4 },
    { StringLiteralConst("Nassau"), 24.6 },
    { StringLiteralConst("Ndola"), 20.3 },
    { StringLiteralConst("New Delhi"), 25.0 },
    { StringLiteralConst("New Orleans"), 20.7 },
    { StringLiteralConst("New York City"), 12.9 },
    { StringLiteralConst("Ngaoundéré"), 22.0 },
    { StringLiteralConst("Niamey"), 29.3 },
    { StringLiteralConst("Nicosia"), 19.7 },
    { StringLiteralConst("Niigata"), 13.9 },
    { StringLiteralConst("Nouadhibou"), 21.3 },
    { StringLiteralConst("Nouakchott"), 25.7 },
    { StringLiteralConst("Novosibirsk"), 1.7 },
    { StringLiteralConst("Nuuk"), -1.4 },
    { StringLiteralConst("Odesa"), 10.7 },
    { StringLiteralConst("Odienné"), 26.0 },
    { StringLiteralConst("Oklahoma City"), 15.9 },
    { StringLiteralConst("Omaha"), 10.6 },
    { StringLiteralConst("Oranjestad"), 28.1 },
    { StringLiteralConst("Oslo"), 5.7 },
    { StringLiteralConst("Ottawa"), 6.6 },
    { StringLiteralConst("Ouagadougou"), 28.3 },
    { StringLiteralConst("Ouahigouya"), 28.6 },
    { StringLiteralConst("Ouarzazate"), 18.9 },
    { StringLiteralConst("Oulu"), 2.7 },
    { StringLiteralConst("Palembang"), 27.3 },
    { StringLiteralConst("Palermo"), 18.5 },
    { StringLiteralConst("Palm Springs"), 24.5 },
    { StringLiteralConst("Palmerston North"), 13.2 },
    { StringLiteralConst("Panama City"), 28.0 },
    { StringLiteralConst("Parakou"), 26.8 },
    { StringLiteralConst("Paris"), 12.3 },
    { StringLiteralConst("Perth"), 18.7 },
    { StringLiteralConst("Petropavlovsk-Kamchatsky"), 1.9 },
    { StringLiteralConst("Philadelphia"), 13.2 },
    { StringLiteralConst("Phnom Penh"), 28.3 },
    { StringLiteralConst("Phoenix"), 23.9 },
    { StringLiteralConst("Pittsburgh"), 10.8 },
    { StringLiteralConst("Podgorica"), 15.3 },
    { StringLiteralConst("Pointe-Noire"), 26.1 },
    { StringLiteralConst("Pontianak"), 27.7 },
    { StringLiteralConst("Port Moresby"), 26.9 },
    { StringLiteralConst("Port Sudan"), 28.4 },
    { StringLiteralConst("Port Vila"), 24.3 },
    { StringLiteralConst("Port-Gentil"), 26.0 },
    { StringLiteralConst("Portland {OR}"), 12.4 },
    { StringLiteralConst("Porto"), 15.7 },
    { StringLiteralConst("Prague"), 8.4 },
    { StringLiteralConst("Praia"), 24.4 },
    { StringLiteralConst("Pretoria"), 18.2 },
    { StringLiteralConst("Pyongyang"), 10.8 },
    { StringLiteralConst("Rabat"), 17.2 },
    { StringLiteralConst("Rangpur"), 24.4 },
    { StringLiteralConst("Reggane"), 28.3 },
    { StringLiteralConst("Reykjavík"), 4.3 },
    { StringLiteralConst("Riga"), 6.2 },
    { StringLiteralConst("Riyadh"), 26.0 },
    { StringLiteralConst("Rome"), 15.2 },
    { StringLiteralConst("Roseau"), 26.2 },
    { StringLiteralConst("Rostov-on-Don"), 9.9 },
    { StringLiteralConst("Sacramento"), 16.3 },
    { StringLiteralConst("Saint Petersburg"), 5.8 },
    { StringLiteralConst("Saint-Pierre"), 5.7 },
    { StringLiteralConst("Salt Lake City"), 11.6 },
    { StringLiteralConst("San Antonio"), 20.8 },
    { StringLiteralConst("San Diego"), 17.8 },
    { StringLiteralConst("San Francisco"), 14.6 },
    { StringLiteralConst("San Jose"), 16.4 },
    { StringLiteralConst("San José"), 22.6 },
    { StringLiteralConst("San Juan"), 27.2 },
    { StringLiteralConst("San Salvador"), 23.1 },
    { StringLiteralConst("Sana'a"), 20.0 },
    { StringLiteralConst("Santo Domingo"), 25.9 },
    { StringLiteralConst("Sapporo"), 8.9 },
    { StringLiteralConst("Sarajevo"), 10.1 },
    { StringLiteralConst("Saskatoon"), 3.3 },
    { StringLiteralConst("Seattle"), 11.3 },
    { StringLiteralConst("Ségou"), 28.0 },
    { StringLiteralConst("Seoul"), 12.5 },
    { StringLiteralConst("Seville"), 19.2 },
    { StringLiteralConst("Shanghai"), 16.7 },
    { StringLiteralConst("Singapore"), 27.0 },
    { StringLiteralConst("Skopje"), 12.4 },
    { StringLiteralConst("Sochi"), 14.2 },
    { StringLiteralConst("Sofia"), 10.6 },
    { StringLiteralConst("Sokoto"), 28.0 },
    { StringLiteralConst("Split"), 16.1 },
    { StringLiteralConst("St. John's"), 5.0 },
    { StringLiteralConst("St. Louis"), 13.9 },
    { StringLiteralConst("Stockholm"), 6.6 },
    { StringLiteralConst("Surabaya"), 27.1 },
    { StringLiteralConst("Suva"), 25.6 },
    { StringLiteralConst("Suwałki"), 7.2 },
    { StringLiteralConst("Sydney"), 17.7 },
    { StringLiteralConst("Tabora"), 23.0 },
    { StringLiteralConst("Tabriz"), 12.6 },
    { StringLiteralConst("Taipei"), 23.0 },
    { StringLiteralConst("Tallinn"), 6.4 },
    { StringLiteralConst("Tamale"), 27.9 },
    { StringLiteralConst("Tamanrasset"), 21.7 },
    { StringLiteralConst("Tampa"), 22.9 },
    { StringLiteralConst("Tashkent"), 14.8 },
    { StringLiteralConst("Tauranga"), 14.8 },
    { StringLiteralConst("Tbilisi"), 12.9 },
    { StringLiteralConst("Tegucigalpa"), 21.7 },
    { StringLiteralConst("Tehran"), 17.0 },
    { StringLiteralConst("Tel Aviv"), 20.0 },
    { StringLiteralConst("Thessaloniki"), 16.0 },
    { StringLiteralConst("Thiès"), 24.0 },
    { StringLiteralConst("Tijuana"), 17.8 },
    { StringLiteralConst("Timbuktu"), 28.0 },
    { StringLiteralConst("Tirana"), 15.2 },
    { StringLiteralConst("Toamasina"), 23.4 },
    { StringLiteralConst("Tokyo"), 15.4 },
    { StringLiteralConst("Toliara"), 24.1 },
    { StringLiteralConst("Toluca"), 12.4 },
    { StringLiteralConst("Toronto"), 9.4 },
    { StringLiteralConst("Tripoli"), 20.0 },
    { StringLiteralConst("Tromsø"), 2.9 },
    { StringLiteralConst("Tucson"), 20.9 },
    { StringLiteralConst("Tunis"), 18.4 },
    { StringLiteralConst("Ulaanbaatar"), -0.4 },
    { StringLiteralConst("Upington"), 20.4 },
    { StringLiteralConst("Ürümqi"), 7.4 },
    { StringLiteralConst("Vaduz"), 10.1 },
    { StringLiteralConst("Valencia"), 18.3 },
    { StringLiteralConst("Valletta"), 18.8 },
    { StringLiteralConst("Vancouver"), 10.4 },
    { StringLiteralConst("Veracruz"), 25.4 },
    { StringLiteralConst("Vienna"), 10.4 },
    { StringLiteralConst("Vientiane"), 25.9 },
    { StringLiteralConst("Villahermosa"), 27.1 },
    { StringLiteralConst("Vilnius"), 6.0 },
    { StringLiteralConst("Virginia Beach"), 15.8 },
    { StringLiteralConst("Vladivostok"), 4.9 },
    { StringLiteralConst("Warsaw"), 8.5 },
    { StringLiteralConst("Washington, D.C."), 14.6 },
    { StringLiteralConst("Wau"), 27.8 },
    { StringLiteralConst("Wellington"), 12.9 },
    { StringLiteralConst("Whitehorse"), -0.1 },
    { StringLiteralConst("Wichita"), 13.9 },
    { StringLiteralConst("Willemstad"), 28.0 },
    { StringLiteralConst("Winnipeg"), 3.0 },
    { StringLiteralConst("Wrocław"), 9.6 },
    { StringLiteralConst("Xi'an"), 14.1 },
    { StringLiteralConst("Yakutsk"), -8.8 },
    { StringLiteralConst("Yangon"), 27.5 },
    { StringLiteralConst("Yaoundé"), 23.8 },
    { StringLiteralConst("Yellowknife"), -4.3 },
    { StringLiteralConst("Yerevan"), 12.4 },
    { StringLiteralConst("Yinchuan"), 9.0 },
    { StringLiteralConst("Zagreb"), 10.7 },
    { StringLiteralConst("Zanzibar City"), 26.0 },
    { StringLiteralConst("Zürich"), 9.3 },
};

f64 CalculateTemperature(f64 temperature) {
    f64 scale = RandomFloat64();
    f64 min = temperature - 5.0;
    f64 max = temperature + 5.0;

    f64 result = min + scale * ( max - min );
    return (result);
}

u32 RunGenerator(memory_arena *arena) {
    u64 frequency = ReadCPUTimerFrequency(100);
    u64 count = Billion(1);
    u64 station_count = ArrayCount(g_weather_station_data);

    file_buffer buffer = FileBuffer(arena, KiB(128));
    void *file = CreateFileToWrite(StringLiteral("measurements.txt"));

    WarmupProfiler();
    profiler_zone zone = StartProfilerZone();

    for (u64 i = 0; i < count; i++) {
        u64 slot = RandomZeroRange64(station_count - 1);
        f64 temperature = CalculateTemperature(g_weather_station_data[slot].temperature);

        u64 arena_pos = GetMemoryArenaPosition(arena);
        string line = StringFormat(arena, "%.*s;%.1f\n", StringToFormatArgs(g_weather_station_data[slot].name), temperature);

        WriteStringToFileBuffer(file, &buffer, line);

        if (i > Million(1)) {
            if (i % Million(1) == 0) {
                line = StringFormat(arena, "Written %_$.2llu lines of measurements.\n", i);
                WriteMessage(line);
            }
        } else if (i % Thousand(100) == 0) {
            line = StringFormat(arena, "Written %_$.2llu lines of measurements.\n", i);
            WriteMessage(line);
        }
        RewindMemoryArenaPosition(arena, arena_pos);
    }

    if (buffer.position > 0) {
        WriteFileBufferToFile(file, &buffer);
    }

    EndProfilerZone(&zone);
    CloseFile(file);

    u64 ticks = zone.ticks_end - zone.ticks_start;
    f64 seconds = (f64)ticks / (f64)frequency;

    string output = StringFormat(arena, "Written %llu lines of measurements in %.2f seconds\n", count, seconds);
    WriteMessage(output);

    return EXIT_CODE_SUCCESS;
}
